=== modified file 'NEWS'
--- NEWS	2007-12-21 05:52:38 +0000
+++ NEWS	2007-12-21 14:53:25 +0000
@@ -55,6 +55,9 @@
 
   BUGFIXES:
 
+   * build_tree acceleration uses the correct path when a file has been moved.
+     (Aaron Bentley)
+
    * Fixed Unicode encoding error in ``ignored`` when the output is
      redirected to a pipe. (Lukáš Lalinský)
 

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2007-12-20 16:38:52 +0000
+++ bzrlib/tests/test_transform.py	2007-12-21 04:12:31 +0000
@@ -1569,6 +1569,23 @@
         self.addCleanup(target.unlock)
         self.assertEqual([], list(target._iter_changes(revision_tree)))
 
+    def test_build_tree_accelerator_tree_moved(self):
+        source = self.make_branch_and_tree('source')
+        self.build_tree_contents([('source/file1', 'A')])
+        source.add(['file1'], ['file1-id'])
+        source.commit('commit files')
+        source.rename_one('file1', 'file2')
+        source.lock_read()
+        self.addCleanup(source.unlock)
+        target = self.make_branch_and_tree('target')
+        revision_tree = source.basis_tree()
+        revision_tree.lock_read()
+        self.addCleanup(revision_tree.unlock)
+        build_tree(revision_tree, target, source)
+        target.lock_read()
+        self.addCleanup(target.unlock)
+        self.assertEqual([], list(target._iter_changes(revision_tree)))
+
 
 class MockTransform(object):
 

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2007-12-20 14:28:59 +0000
+++ bzrlib/transform.py	2007-12-21 04:12:31 +0000
@@ -1467,7 +1467,7 @@
         new_desired_files = desired_files
     else:
         iter = accelerator_tree._iter_changes(tree, include_unchanged=True)
-        unchanged = dict((f, p[0]) for (f, p, c, v, d, n, k, e)
+        unchanged = dict((f, p[1]) for (f, p, c, v, d, n, k, e)
                          in iter if not c)
         new_desired_files = []
         for file_id, identifier in desired_files:

